package com.its.api.its.service.link;

import com.its.api.config.ProcessConfig;
import com.its.api.its.model.dto.link.TbLinkDto;
import com.its.api.its.model.entity.link.TbLink;
import com.its.api.its.repository.link.TbLinkRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbLinkService {

    private final ProcessConfig processConfig;
    private final TbLinkRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbLink requireOne(Long id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    /**
     * 링크 관리 전체 데이터 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbLinkDto> findAll() {
        List<TbLinkDto> result = new ArrayList<>();
        List<TbLink> data = this.repo.findAll();
        for (TbLink entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    /**
     * 삭제되지 않은 링크 전체 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbLinkDto> findAllList() {
        List<TbLinkDto> result = new ArrayList<>();
        List<TbLink> data = this.repo.findAllList();
        for (TbLink entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 지역센터 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbLinkDto> findLocalAll() {
        List<TbLinkDto> result = new ArrayList<>();
        List<TbLink> data = this.repo.findAll();
        for (TbLink entity : data) {
            if (("LAT001").equals(entity.getAreaCd())) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    // 지역센터 도로 링크 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbLinkDto> findLocalRoadLinkAll() {
        //int regionCode = Integer.parseInt(this.processConfig.getRegionCode());
        List<TbLinkDto> result = new ArrayList<>();
        List<TbLink> data = this.repo.findLocalRoadLinkAll();
        for (TbLink entity : data) {
            //if ((entity.getLinkId() / 10000000) == regionCode) {
                result.add(entity.toDto());
            //}
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbLinkDto findById(Long id) {
        TbLink entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbLinkDto updateById(Long id, TbLinkDto.TbLinkUpdReq req) {
        TbLink entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 도로명 변경
    @Transactional
    public TbLinkDto updateNameById(Long id, TbLinkDto.TbLinkNameUpdReq req) {
        TbLink entity = requireOne(id);
        entity.updateName(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbLinkDto> mergeInfoList(List<TbLinkDto.TbLinkUpdReq> reqList) {
        List<TbLinkDto> result = new ArrayList<>();
        for (TbLinkDto.TbLinkUpdReq req : reqList) {
            TbLink obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbLinkDto mergeInfo(TbLinkDto.TbLinkUpdReq req) {
        TbLink obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbLinkDto deleteById(Long id) {
        TbLink entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbLinkDto> deleteByIds(List<Long> ids) {
        List<TbLinkDto> result = new ArrayList<>();
        for (Long id : ids) {
            Optional<TbLink> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    /**
     * 지도검색
     * @param filter
     * @return
     */
    public List<TbLinkDto> findByFilter(String filter) {
        List<TbLinkDto> result = new ArrayList<>();
        List<TbLink> data = this.repo.findAll();
        data.forEach(obj -> {
            if (("Y").equals(obj.getDelYn())) {
                return;
            }
            if (filter == null || filter.isEmpty()) {
                result.add(obj.toDto());
            } else {
                if ((obj.getRoadName() != null && obj.getRoadName().contains(filter)) || String.valueOf(obj.getLinkId()).contains(filter)) {
                    result.add(obj.toDto());
                }
            }
        });
        return result;
    }
}
